/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */
/*
 * Chroma widget set
 * (C) 2005 M. Derezynski <internalerror@gmail.com> 
 *
 */

#ifndef CHROMA_VSCROLLBAR_H
#define CHROMA_VSCROLLBAR_H

/*
 * Potentially, include other headers on which this header depends.
 */
#include <glib-object.h>

#define CHROMA_TYPE_VSCROLLBAR		  (chroma_vscrollbar_get_type ())
#define CHROMA_VSCROLLBAR(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHROMA_TYPE_VSCROLLBAR, ChromaVScrollbar))
#define CHROMA_VSCROLLBAR_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), CHROMA_TYPE_VSCROLLBAR, ChromaVScrollbarClass))
#define CHROMA_IS_VSCROLLBAR(obj)	  (GTK_CHECK_TYPE ((obj), CHROMA_TYPE_VSCROLLBAR))
#define CHROMA_IS_VSCROLLBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHROMA_TYPE_VSCROLLBAR))
#define CHROMA_VSCROLLBAR_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), CHROMA_TYPE_VSCROLLBAR, ChromaVScrollbarClass))

typedef struct _ChromaVScrollbar ChromaVScrollbar;
typedef struct _ChromaVScrollbarClass ChromaVScrollbarClass;
typedef struct _ChromaVScrollbarPrivate ChromaVScrollbarPrivate;

struct _ChromaVScrollbar {
	GObject parent;

        ChromaVScrollbarPrivate *private;
};

struct _ChromaVScrollbarClass {
	GObjectClass parent;

	void (*position)       (ChromaVScrollbar *scrollbar, gdouble position);
	void (*expose_request) (ChromaVScrollbar *scrollbar);
};

/* used by CHROMA_TYPE_VSCROLLBAR */
GType chroma_vscrollbar_get_type (void);

GObject*
chroma_vscrollbar_new (void);

void
chroma_vscrollbar_draw (ChromaVScrollbar *self, GdkDrawable *drawable, cairo_t *cr);

gboolean
chroma_vscrollbar_dispatch_button_press (ChromaVScrollbar *self, GdkEventButton *event); 

gboolean
chroma_vscrollbar_dispatch_button_release (ChromaVScrollbar *self, GdkEventButton *event); 

gboolean
chroma_vscrollbar_dispatch_motion (ChromaVScrollbar *self, GdkEventMotion *event); 

/* Added by Kenneth "Langly" Østby */
gboolean 
chroma_vscrollbar_dispatch_scroll(ChromaVScrollbar *self, GdkEventScroll *event);

gboolean 
chroma_vscrollbar_dispatch_scroll_direct(ChromaVScrollbar *self, GdkEventScroll *event);

gboolean 
chroma_vscrollbar_get_inside(ChromaVScrollbar *self);

void
chroma_vscrollbar_emit_expose_request (ChromaVScrollbar *self);

void
chroma_vscrollbar_reset (ChromaVScrollbar *self);

void
chroma_vscrollbar_move_resize(ChromaVScrollbar * self, gint pos_x, gint pos_y, gint w, gint h);
 
#endif /* CHROMA_VSCROLLBAR_H */



